#!/bin/bash

if (grep "multimonitor=yes" /data/user/thinclient/config/system.conf)
then
  if (test -e /data/user/thinclient/config/multimonitor)
  then
    if (test -e /data/user/thinclient/dispsetup.sh)
   then
      sh /data/user/thinclient/dispsetup.sh
    fi
    MONITOR1=$(/opt/thinclient/script/getmonitor.sh 1)
    MONITOR2=$(/opt/thinclient/script/getmonitor.sh 2)  
    if [ "$MONITOR2" = "" ]
    then
      exit 0
    fi
  
    ORIENTATION=$(grep "orientation=" /data/user/thinclient/config/multimonitor | cut -d= -f2)
    RESOLUTION=$(grep "resolution2=" /data/user/thinclient/config/system.conf | cut -d= -f2)
  
    # set resolution for monitor 2
    MODE=""
    if [ "$RESOLUTION" != "" ]
    then
      MODE="--output "$MONITOR2" --mode "${RESOLUTION}
    fi
    if [ "$RESOLUTION" = "auto" ]
    then
      MODE="--output "$MONITOR2" --auto"
    fi
    case $ORIENTATION in 
    left)
        xrandr --output $MONITOR1 --left-of $MONITOR2 $MODE
        ;;
    right)
        xrandr --output $MONITOR1 --right-of $MONITOR2 $MODE
        ;;
    above)
        xrandr --output $MONITOR1 --above $MONITOR2 $MODE
        ;;
    below)
        xrandr --output $MONITOR1 --below $MONITOR2 $MODE
        ;;   
    esac
  fi
fi
exit 0
