#! /bin/sh

mount -o remount,rw /boot

if (test -s /data/user/thinclient/config/interfaces)
then
  cp /data/user/thinclient/config/interfaces /etc/network/interfaces
  rm /data/user/thinclient/config/interfaces
fi
       
if (test -s /data/user/thinclient/config/netplan)
then
  NETPLANFILE=$(ls /etc/netplan)
  cp /data/user/thinclient/config/netplan /etc/netplan/$NETPLANFILE
  rm /data/user/thinclient/config/netplan
fi
    
if (test -s /data/user/thinclient/config/dhcpcd)
then
  cp /data/user/thinclient/config/dhcpcd /etc/dhcpcd.conf
  rm /data/user/thinclient/config/dhcpcd
fi
    
if (test -s /data/user/thinclient/config/resolv.conf)
then
  cp /data/user/thinclient/config/resolv.conf /etc
  rm /data/user/thinclient/config/resolv.conf
fi
    
if (test -s /data/user/thinclient/config/wlan)
then
  cp /data/user/thinclient/config/wlan /etc/wpa_supplicant/wpa_supplicant.conf
  chown root:root /etc/wpa_supplicant/wpa_supplicant.conf
  chmod u=rw,g=r,o=r /etc/wpa_supplicant/wpa_supplicant.conf
  rm /data/user/thinclient/config/wlan
fi

# remove wpa_supplicant
if (test -s /data/user/thinclient/config/wlanremove)
then
  rm /etc/wpa_supplicant/wpa_supplicant.conf
  rm /data/user/thinclient/config/wlanremove
fi
    
if (test -s /data/user/thinclient/config/keyboard)
then
  sh /opt/thinclient/script/setkeyboard.sh
  rm /data/user/thinclient/config/keyboard
fi

if (test -s /data/user/thinclient/config/configuration)
then
  sh /data/user/thinclient/config/configuration
  rm /data/user/thinclient/config/configuration
fi
    
if (test -s /data/user/thinclient/config/argon1start)
then
  sh /opt/thinclient/script/argon1start.sh
  rm /data/user/thinclient/config/argon1start
fi
    
if (test -s /data/user/thinclient/config/argon1stop)
then
  sh /opt/thinclient/script/argon1stop.sh
  rm /data/user/thinclient/config/argon1stop
fi    
    
if (test -s /data/user/thinclient/config/usbautomounton)
then
  sh /opt/thinclient/script/setusb.sh on
  rm /data/user/thinclient/config/usbautomounton
fi    
    
if (test -s /data/user/thinclient/config/usbautomountoff)
then
  sh /opt/thinclient/script/setusb.sh off
  rm /data/user/thinclient/config/usbautomountoff
fi

# set sound card
if (test -s /data/user/thinclient/config/soundcard)
then
  sh /opt/thinclient/script/setsoundcard.sh
  rm /data/user/thinclient/config/soundcard
fi    

# set password for ssh user
if (test -s /data/user/thinclient/config/sshpass)
then
  sh /opt/thinclient/script/setsshpassword.sh
  rm /data/user/thinclient/config/sshpass
fi    

# set time
if (test -s /data/user/thinclient/config/time)
then
  sh /opt/thinclient/script/configtime.sh
  rm /data/user/thinclient/config/time
fi 

# change root password
if (test -s /data/user/thinclient/config/rootpassword)
then
  PASSWD=$(cat /data/user/thinclient/config/rootpassword)
  echo root:$PASSWD | chpasswd
  rm /data/user/thinclient/config/rootpassword
fi

# change thinclient password
if (test -s /data/user/thinclient/config/userpassword)
then
  PASSWD=$(cat /data/user/thinclient/config/userpassword)
  echo thinclient:$PASSWD | chpasswd      
  rm /data/user/thinclient/config/userpassword
fi

# set system name
if (test -s /data/user/thinclient/config/systemname)
then
  SYSTEMNAME=$(cat /data/user/thinclient/config/systemname)
  echo $SYSTEMNAME > /etc/hostname
  rm /data/user/thinclient/config/systemname
fi

# set screensaver
if (test -s /data/user/thinclient/config/screensaver)
then
  sh /opt/thinclient/script/screensaver.sh
  rm /data/user/thinclient/config/screensaver
fi

# set monitor standby
if (test -s /data/user/thinclient/config/standby)
then
  sh /opt/thinclient/script/monitorstandby.sh
  rm /data/user/thinclient/config/standby
fi

# set one nine design case
if (test -s /data/user/thinclient/config/onenine)
then
  sh /opt/thinclient/script/oneninedesign.sh
  rm /data/user/thinclient/config/onenine
fi

# set resolution
if (test -s /data/user/thinclient/config/resolution)
then
  sh /opt/thinclient/script/setresolution.sh
  rm /data/user/thinclient/config/resolution
fi

# set taskbar
if (test -s /data/user/thinclient/config/taskbar)
then
  sh /opt/thinclient/script/settaskbar.sh
  rm /data/user/thinclient/config/taskbar
fi

# set sound control
if (test -s /data/user/thinclient/config/controlsound)
then
  sh /opt/thinclient/script/setcontrolsound.sh
  rm /data/user/thinclient/config/controlsound
fi

# set background color
if (test -s /data/user/thinclient/config/backgroundcolor)
then
  sh /opt/thinclient/script/setbackgroundcolor.sh
  rm /data/user/thinclient/config/backgroundcolor
fi

# set background image
if (test -s /data/user/thinclient/config/backgroundimage)
then
  sh /opt/thinclient/script/setbackgroundimage.sh
  rm /data/user/thinclient/config/backgroundimage
fi

# set or remove dtoverlay
sh /opt/thinclient/script/setgraphic.sh
rm /data/user/thinclient/config/graphic

# set dns server (Raspberry Pi)
sh /opt/thinclient/script/setdnspi.sh

# simple context menu, virtual console
sh /opt/thinclient/script/security.sh

# set numeric keypad
sh /opt/thinclient/script/numerickeypad.sh

# save icons
cp -a /home/thinclient/.idesktop /var/thinclient/home/thinclient

# encrypt data
# /opt/thinclient/script/encryptdata.sh: execute in reboot.sh

# create initramfs for overlay mode 
#/opt/thinclient/script/mkinitrd.sh
# set overlay mode
/opt/thinclient/script/overlay.sh

rm -r tmp/* 

exit 0
